#!/bin/sh

# USAGE: ./mailman2sympa nom_fichier
# Le fichier contient la liste des listes  migrer

. conf/mailman2sympa.conf

if [ ! -d $WDIR ]; then
	mkdir -p $WDIR
fi

if [ $# = 0 ] ; then
	ls -1 $MAILMAN_HOME/lists/ | sed 's=/==g' > $WDIR/mailman-lists
	set $WDIR/mailman-lists
else
	echo "$1" > $WDIR/mailman-lists
	set $WDIR/mailman-lists
fi

if [ ! -d $EXPL ] ; then
	mkdir $EXPL
	fi

if [ ! -d $WDIR/lists ] ; then
	mkdir $WDIR/lists
	fi
	
if [ ! -d $WDIR/csv ] ; then
	mkdir $WDIR/csv
	fi
echo
echo Picking up configuration of mailman lists

for f in `cat $1` ; do
        $MAILMAN_HOME/bin/dumpdb $MAILMAN_HOME/lists/$f/config.db > $WDIR/lists/$f
        perl -pe 's/\\([0-3][0-7][0-7])/chr(oct($1))/eg;' $WDIR/lists/$f > $WDIR/lists/$f.perl
        mv -f $WDIR/lists/$f.perl $WDIR/lists/$f
done

echo
echo Creating configuration files for Sympa lists
ALIASES="$WDIR/aliases-sympa"
echo -n "" > $WDIR/aliases-sympa
for l in `cat $1` ; do
	if [ ! -d $EXPL/$l ] ; then
		mkdir $EXPL/$l
		fi
	awk -v LIST=$l -v ALIASES=$ALIASES -v PREFIX=$ALIAS_PREFIX -v DOMAIN=$DOMAIN -v SMTPSCRIPTPATH=$SYMPA_SMTPSCRIPTS -v OWNER=$DEFAULT_OWNER -f awk/mailman2sympa.awk $WDIR/lists/$l > $EXPL/$l/config
	done

echo
echo Creating subscribers files

echo -n "" > $WDIR/csv/import_users.csv
echo -n "" > $WDIR/csv/import_subscribers.csv
for  l in `cat $1` ; do 
	awk -v EXPL=$EXPL -v LIST=$l -v WDIR=$WDIR -v NOMAIL=$TAKE_NOMAIL -v DATE=$DEFAULT_DATE -f awk/subscribers.awk $WDIR/lists/$l
	done
echo
echo Giving lists configuration to $USER
chown -R ${USER}:${GROUP} $EXPL

if [ $CONVERT_ARCHIVE = "yes" ] ; then
	./scripts/getmailmanarchive $1
fi

echo
echo Cleaning...

rm -rf $WDIR/lists/ NUM

echo 
echo -n "Do you want to import subscribers from CSV? [y/n]: "
read IMPORT

if [ "$IMPORT" == "y" ]; then
	./loadsubscribers.sh
fi

echo
echo Done.
echo
